#ifndef __A1800_H__
#define __A1800_H__

typedef enum
{
	A1800_NO_ERR = 0,
	A1800_CAN_NOT_OPEN_IN_WAVE_FILE,
	A1800_CAN_NOT_OPEN_OUT_WAVE_FILE,
	A1800_CAN_NOT_OPEN_CODE_FILE,
	A1800_WAVE_FILE_FORMAT_ERR,
	A1800_CODE_FILE_FORMAT_ERR,
	A1800_NOT_ENOUGH_WAVE,
	A1800_NOT_ENOUGH_BS,
	A1800_MODE_ERR,
	A1800_USER_ABORT,
} A1800_RESULT;

typedef struct
{
	long cwWaveSize;
	long cntWave;
	long cwBitstreamSize;
	long cntBitstream;
} A1800_STATUS;

typedef int A1800_CALLBACK(const A1800_STATUS *status);

//#ifdef _WIN32
typedef A1800_RESULT A1800_ENC_FRAME_INITIAL(
		int BitRate, 
        int *PackageSize, 
        int *SamplePreFrame);

typedef A1800_RESULT A1800_ENC_FRAME( 
		const short *PCM,
        short *BS);
//#endif

typedef A1800_RESULT A1800_DEC_FRAME_INITIAL(
		int BitRate, 
        int *PackageSize, 
        int *SamplePreFrame);

typedef A1800_RESULT A1800_DEC_FRAME(
		const short *BS,
        short *PCM);

//#ifdef _WIN32
typedef A1800_RESULT A1800_ENC(
	const char *InWaveFileName,
	const char *CodeFileName,
	int BitRate,
	int *fs,
	A1800_CALLBACK fcn);
//#endif

typedef A1800_RESULT A1800_DEC(
	const char *CodeFileName,
	const char *OutWaveFileName,
	int *BitRate,
	int fs,
	A1800_CALLBACK fcn);

#endif