#ifndef _SAFEDEL_H_
#define _SAFEDEL_H_

#ifndef SAFE_DELETE
#define	SAFE_DELETE(p)	{\
	if (p != NULL)\
	{\
		delete p;\
		p = NULL;\
	}\
}
#endif //SAFE_DELETE

#ifndef SAFE_DELETE_ARRAY
#define SAFE_DELETE_ARRAY(p)	{\
	if (p != NULL)\
	{\
		delete [] p;\
		p = NULL;\
	}\
}
#endif //SAFE_DELETE_ARRAY

#ifndef SAFE_RELEASE
#define	SAFE_RELEASE(p)	{\
	if (p != NULL)\
	{\
		p->Release();\
		p = NULL;\
	}\
}
#endif

#ifndef SAFE_CLOSE_HANDLE
#define	SAFE_CLOSE_HANDLE(h)	{\
	if (h != NULL)\
	{\
		::CloseHandle(h);\
		h = NULL;\
	}\
}
#endif


#ifndef SAFE_FREE_LIBRARY
#define	SAFE_FREE_LIBRARY(h)	{\
	if (h != NULL)\
	{\
		::FreeLibrary(h);\
		h = NULL;\
	}\
}
#endif

#ifndef SAFE_CLOSE_FILE_HANDLE
#define	SAFE_CLOSE_FILE_HANDLE(h)	{\
	if (h != INVALID_HANDLE_VALUE)\
	{\
		::CloseHandle(h);\
		h = INVALID_HANDLE_VALUE;\
	}\
}
#endif

#ifndef SAFE_CLOSE_FILE
#define	SAFE_CLOSE_FILE(fp)	{\
	if (fp != NULL)\
	{\
		::fclose(fp);\
		fp = NULL;\
	}\
}
#endif


#endif	// _SAVEDEL_H_
